//
//   dbs.prg Written by Ted Long 11/08/92
//   Released to the public domain
//   Compile with /n option
//
#include "dbstruct.ch"
#include "Directry.ch"
#include "ERROR.ch"

//
FUNCTION showstru()
//
LOCAL oldscreen := SAVESCREEN(0,0,24,79)
CLS

MEMVAR->dbffile := loaddir( "*.dbf" )

 IF MEMVAR->dbffile != NIL

   // Capture the output of DbfInfo to a text file
   SET ALTER TO STRU.ST$
   SET ALTER ON
   SET CONSOLE OFF

   // One of the functions contained in TL.LIB
   Dbfinfo(MEMVAR->dbffile)

   SET ALTER OFF
   CLOSE ALTER
   SET CONSOLE ON
 ENDI

CLOSE DATA
USE
SETCOLOR("")
RESTSCREEN(0,0,24,79, oldscreen )

//Bye bye we gone.
RETURN NIL


//
// DbfInfo()
//
// This function is a sample of the functions contained in TL.lib.
// its purpose is to provide a summary of the structure of a given
// .dbf file in a format that looks like your favorite interpreter.
// Since it will scroll the information on the screen, it is
// recommended that you capture the stuff to a file for future
// viewing. See the code example above.
//
// Syntax :   DbfInfo( <cFilename> )
// Returns:   Not a thing (NIL)
//
FUNCTION dbfinfo(dbffile)
//
local num_recs, lastupdate
local flds_arr, fldlen := 0, i := 1, indent := 12
local bSaveHandler, error

// make sure that the file is ok. if not exit gracefully
bSaveHandler := ERRORBLOCK( {|x| BREAK(x)} )

BEGIN SEQUENCE
    USE (dbffile) ALIAS dbffile NEW READONLY
RECOVER USING error
    IF error:genCode == EG_OPEN
        qout("")
        qout(SPACE(indent)+"<ERROR> in reading file : "+dbffile)
        qout("")
        qout("")
        qout("")
    ELSE
        qout("")
        qout(SPACE(indent)+"<ERROR> in reading file : "+dbffile)
        qout("")
        qout("")
        qout("")
    ENDIF
    RETURN NIL
END

lastupdate := DTOC(LUPDATE())
num_recs   := ALLTRIM(STR(LASTREC()))
dbffile    := CURDIR()+CHR(92)+dbffile
flds_arr   := dbffile->(DBSTRUCT())
CLOSE DATA
USE

// output the structure stuff

QOUT(SPACE(indent)+"Structure of file : "+dbffile)
QOUT(SPACE(indent)+"Last updated   : "+lastupdate)
QOUT(SPACE(indent)+"Total number of records in file : "+num_recs)
QOUT(SPACE(indent)+"Total number of fields in file  : ";
             +ALLTRIM(STR(LEN(flds_arr))))
QOUT("")
QOUT(SPACE(indent)+"Fld_Name       Fld_Len   Fld_Type   Fld_Dec")
QOUT(SPACE(indent)+"========       =======   ========   =======")

AEVAL(flds_arr, { |y|  QOUT(STR(i++)+"   "+PADR(y[DBS_NAME],10),;
  PADR(STR(y[DBS_LEN]),17), ALLTRIM(y[DBS_TYPE]),;
  IF( y[DBS_TYPE] == "N", PADL(STR(y[DBS_DEC]),10),"")  )   })

AEVAL(flds_arr, { |x| fldlen := fldlen + x[DBS_LEN] })

QOUT("")
QOUT(SPACE(indent)+"** Total          "+ALLTRIM(STR(fldlen)))
QOUT("")
// QOUT(REPLICATE("-", 75))
QOUT("")

// go back to calling routine
RETURN NIL

//
// DbfInfo()
//
// This function is a sample of the functions contained in TL.lib.
// Its purpose is to load an array with filenames and related info
// and via Achoice() will allow the user to make a choice of a
// dbf file to use.
//
// Syntax  : LoadDir(<cfilespec>, <cFiletype> )
// Returns : Nil if the Escape, right or left arrow key(s) are
//           Pressed. The filename if the Return key is pressed.
//
FUNCTION loaddir(file_ext, file_type)
//
LOCAL direc_a, direc_b, load_scr, top_row, left_col,;
   right_col, bot_row, gotafile, fpick, max_row

IF PCOUNT() == 1
   file_type := ""
ENDI

max_row := 22
direc_a := DIRECTORY(file_ext, file_type)
direc_b := {}
AEVAL(direc_a, {|files| aadd(direc_b, PADR(files[F_NAME],13) + STR(files[F_SIZE]);
   + "  " +DTOC(files[F_DATE]) +"  "+files[F_TIME]) })

**/   direc_b is now the array containing file names, size, data, and time.
ASORT(direc_b)

IF LEN(direc_b) = 0
   Err_Box("There are no files that meet your request. Press any Key.." )
   gotafile := NIL
   RETURN(gotafile)
ENDI

top_row   :=  5
left_col  := 15
right_col := 63
IF top_row+5+LEN(direc_b) < max_row
   bot_row := top_row+5+LEN(direc_b)
ELSE
   bot_row := max_row
ENDI

load_scr := SAVESCREEN(top_row, left_col, bot_row+2, right_col+2)

@ top_row, left_col, bot_row, right_col BOX 'Ŀ'

@ top_row+1, left_col+3 SAY "File Name"
@ top_row+1, 37 SAY "Size"
@ top_row+1, 44 SAY "Date"
@ top_row+1, 54 SAY "Time"
@ top_row+2, left_col SAY REPLICATE("",48)
@ top_row+2, left_col SAY ''
@ top_row+2, right_col SAY ''
@ bot_row-2, left_col SAY REPLICATE("",48)
@ bot_row-2, left_col SAY ''
@ bot_row-2, right_col SAY ''
@ bot_row-1, left_col+3 SAY "<Enter> to Pick              <Esc> to exit"

fpick := ACHOICE( top_row+3, left_col+3, bot_row-3, right_col-1, direc_b )

DO CASE
CASE LASTKEY() = 13
   gotafile := ALLTRIM(SUBSTR(direc_b[fpick],1,12))
CASE LASTKEY() = 27
   gotafile := NIL
CASE LASTKEY() = 19
   gotafile := NIL
CASE LASTKEY() = 4
   gotafile := NIL
ENDCASE

RESTSCREEN(top_row, left_col, bot_row+2, right_col+2,load_scr )
RETURN(gotafile)

//
FUNCTION err_box(M_string)
//
LOCAL length, beg_it, end_it, mrow := 12

IF LEN(ALLTRIM(M_string)) >= 76
   length := 76
   M_string := SUBSTR(M_string,1,76)
ELSE
   length := ROUND(LEN(ALLTRIM(M_string)),0)
ENDI

beg_it := ROUND((80-length)/2,0)-2
end_it := ROUND(((80-length)/2)+length,0)+1

@ mrow-1, beg_it, mrow+1, end_it BOX 'Ŀ'
@ mrow-1, 34 SAY "   ERROR   "
@ mrow,(beg_it +2) SAY ALLTRIM(M_string)

TONE(100,2)
TONE(150,2)
INKEY(0)

RETURN NIL
